#!/usr/bin/perl -w
# $Id: mt-nofollow.cgi,v 1.1.2.3 2005/01/24 18:37:14 bchoate Exp $
# Released under the Artistic License

use strict;

my($MT_DIR);
BEGIN {
    use File::Basename;

    $MT_DIR = $ENV{PWD} if !$MT_DIR || $MT_DIR !~ m|^/|;
    $MT_DIR = dirname($ARGV[0])
        if (!$MT_DIR || $MT_DIR) !~ m|^/| && $ARGV[0];
    $MT_DIR = dirname($ENV{SCRIPT_FILENAME}) 
        if (!$MT_DIR || $MT_DIR !~ m|^/|) && $ENV{SCRIPT_FILENAME};

    $MT_DIR =~ s|/plugins/.*$|/|;
    unshift @INC, $MT_DIR . 'lib';
    unshift @INC, $MT_DIR . 'extlib';
    unshift @INC, $MT_DIR . 'plugins';
}

package MT::App::Nofollow;

use MT::App::CMS;
use vars qw(@ISA);
@ISA = qw(MT::App::CMS);

sub init {
    my $app = shift;
    $app->SUPER::init (@_) or return;
    $SIG{__WARN__} = 0;
    $app->add_methods (
        default => \&show_form,
        save => \&save_form        
    ); 
    $app->{default_mode} = 'default';
    my $mode = $app->{query}->param('__mode');
    use File::Spec;
    $app->{plugin_template_path} = File::Spec->catdir('plugins', 'nofollow', 'tmpl');
    $app->{cfg}->set('AltTemplatePath', '');
    $app->{requires_login} = 1; 

    $app;   
}

sub uri {
    shift->mt_uri(@_);
}

sub show_form {
    my $app = shift;
    my (%param) = @_;
    require MT::PluginData;
    my $pd = MT::PluginData->load({plugin => 'Nofollow',
                                   key => 'configuration'});
    my $data = $pd ? $pd->data() || {} : {};
    my $author = $app->{author};
    return $app->error("You cannot edit the settings for Nofollow")
        unless $author->can_create_blog;
    $data->{nofollow_enabled} = 1 unless exists $data->{nofollow_enabled};
    $data->{follow_auth_links} = 0 unless exists $data->{follow_auth_links};
    $param{$_} = $data->{$_} foreach $app->config_params;
    $app->add_breadcrumb( 'Nofollow Plugin' );
    $app->build_page('nofollow.tmpl', \%param);
}

sub config_params {
    qw(nofollow_enabled follow_auth_links);
}

sub save_form {
    my $app = shift;
    my $auth = $app->{author};
    my $q = $app->{query};
    my $author = $app->{author};
    return $app->error("You cannot edit the settings for Nofollow") unless $author->can_create_blog;
    require MT::PluginData;
    my $pd = MT::PluginData->load({plugin => 'Nofollow',
                                   key => 'configuration'});
    if (!$pd) {
        $pd = new MT::PluginData;
        $pd->plugin('Nofollow');
        $pd->key('configuration');
    }
    my $config = $pd->data() || {};
    $config->{$_} = $q->param($_) || undef foreach $app->config_params;
    $pd->data($config);
    $pd->save or die $pd->errstr;
    my %param;
    $param{message} = "Settings updated.";
    $app->show_form(%param);
}

eval {
    my $app = MT::App::Nofollow->new(
        Config => $MT_DIR . 'mt.cfg',
        Directory => $MT_DIR
    ) or die MT::App::Nofollow->errstr;
    local $SIG{__WARN__} = sub { $app->trace ($_[0]) };
    $app->run;
};

if ($@) {
    print "Content-Type: text/html\n\n";
    print "An error occurred: $@";
}
